#ifndef _DIALOGS_SPLASH_CPP
#define _DIALOGS_SPLASH_CPP
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#include <Windows.H>
#include <Stdio.H>
#include <Stdlib.H>
#include <CommCtrl.h>

#include "../Resources/Resource.H"

#include "../../SharedSource/NSWFL.H"
#include "../Source/Entry.H"
#include "../Source/Routines.H"

#include "../Dialogs/MainDlg.H"

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

HWND SplashProgress_hWnd = NULL;

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

BOOL CALLBACK SplashDialog(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
    //--------------------------------------------------------------------------

    static HWND VersionTag_hWnd = NULL;

    static int StatusPos = 0;

    //--------------------------------------------------------------------------

    if(uMsg == WM_INITDIALOG)
    {
        StatusPos = 0;

        SendMessage(hWnd, (UINT)WM_SETTEXT, (WPARAM)0, (LPARAM)"Loading...");
        SendMessage(hWnd, WM_SETICON, TRUE, (LPARAM) LoadIcon(ghAppInstance, MAKEINTRESOURCE(IDI_MAIN)) );

        SplashProgress_hWnd = GetDlgItem(hWnd, IDC_SPLASHPROGRESS);
        VersionTag_hWnd     = GetDlgItem(hWnd, IDC_VERSIONTAG);

        char VersionTag[255];
        sprintf(VersionTag, "%s [Version: %s]", gsTitleCaption, gsFileVersion);
        Set_Text(VersionTag_hWnd, VersionTag);

		SetTimer(hWnd, 0, 25, NULL);

        CenterWindow(hWnd);

        return TRUE;
    }

    //--------------------------------------------------------------------------

    if(uMsg == WM_CTLCOLORSTATIC)
    {
        if((HANDLE)lParam == VersionTag_hWnd)
            return Set_Color(RGB(255, 0, 0), RGB(255, 255, 255), wParam);

        return FALSE;
    }

    //--------------------------------------------------------------------------

    if(uMsg == WM_TIMER)
    {
        StatusPos = (StatusPos + 2);
        SendMessage(SplashProgress_hWnd, (UINT)PBM_SETPOS, (WPARAM)StatusPos, (LPARAM)0);

        if(StatusPos >= 100)
        {
            StatusPos = 0;
            KillTimer(hWnd, 0);
            EndDialog(hWnd,0);
            DestroyWindow(hWnd);
            SetForegroundWindow(MainDialog_hWnd);
        }

        return TRUE;
    }

    //--------------------------------------------------------------------------

    if(uMsg == WM_COMMAND)
    {

        return FALSE;
    }

    //--------------------------------------------------------------------------

	if(uMsg == WM_PAINT)
    {
        HDC ThisHDC;
        PAINTSTRUCT ThisPS;

        ThisHDC = BeginPaint(hWnd, &ThisPS);

        // Any painting should be done here

        EndPaint(hWnd, &ThisPS);
        return TRUE;
    }

    //--------------------------------------------------------------------------

    if(uMsg == WM_CLOSE)  // Received Close Message
    {
        KillTimer(hWnd, 0);
        EndDialog(hWnd,0);
        DestroyWindow(hWnd);
        return TRUE;
    }

    //--------------------------------------------------------------------------

    return FALSE;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#endif

