#ifndef _DIALOGS_TABADVANCED_CPP
#define _DIALOGS_TABADVANCED_CPP
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#include <Windows.H>
#include <Stdio.H>
#include <Stdlib.H>
#include <CommCtrl.h>

#include "../Resources/Resource.H"

#include "../../SharedSource/NSWFL.H"
#include "../Source/Entry.H"
#include "../Source/Routines.H"

#include "../Dialogs/MainDlg.H"

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

BOOL CALLBACK TabAdvancedDialog(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{

	if(uMsg == WM_INITDIALOG)
    {
		if(gbCacheLogFile)
			CheckDlgButton(hWnd, IDC_CACHELOGFILE, BST_CHECKED);

		if(gbShowSplashScreen)
			CheckDlgButton(hWnd, IDC_SHOWSPLASHSCREEN, BST_CHECKED);

		if(gbDropBadPackets)
			CheckDlgButton(hWnd, IDC_DROPBADPACKETS, BST_CHECKED);

		if(gbPacketMode)
			CheckDlgButton(hWnd, IDC_USEPACKEMODE, BST_CHECKED);

		return TRUE;
    }

	if(uMsg == WM_NOTIFY)
    {
        LPNMHDR pNMH = (LPNMHDR)lParam;
        if(pNMH->code == PSN_KILLACTIVE)
        {
            return FALSE;
        }
        if(pNMH->code == PSN_APPLY) // Ok
        {
			gbCacheLogFile = (IsDlgButtonChecked(hWnd, IDC_CACHELOGFILE) == BST_CHECKED);
			gbShowSplashScreen = (IsDlgButtonChecked(hWnd, IDC_SHOWSPLASHSCREEN) == BST_CHECKED);
			gbDropBadPackets = (IsDlgButtonChecked(hWnd, IDC_DROPBADPACKETS) == BST_CHECKED);
			gbPacketMode = (IsDlgButtonChecked(hWnd, IDC_USEPACKEMODE) == BST_CHECKED);

			return TRUE;
        }
        if(pNMH->code == PSN_RESET) // Cancel
        {
            return FALSE;
        }
    }

    return FALSE;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#endif
