#ifndef _TABSECURITY_H
#define _TABSECURITY_H
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#include <Windows.H>
#include <Stdio.H>
#include <Stdlib.H>

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#include "../Resources/Resource.H"

#include "../../SharedSource/NSWFL.H"
#include "../../SharedSource/CRC32.H"

#include "../Source/Entry.H"
#include "../Source/Init.H"
#include "../Source/WinService.H"
#include "../Source/Routines.H"

#include "../CSockSrvr/CSockSrvr.H"

#include "../Dialogs/MainDlg.H"

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

BOOL CALLBACK TabSecurityDialog(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
    static HWND AuthString_hWnd;
    static HWND AuthKey_hWnd;
    static HWND EncryptKeyLength_hWnd;
    static HWND AdminPassword1_hWnd;
    static HWND AdminPassword2_hWnd;

    if(uMsg == WM_INITDIALOG)
    {
        char sText[1024];
		int iLength = 0;

		AuthString_hWnd        = GetDlgItem(hWnd, IDC_AUTHSTRING);
        AuthKey_hWnd           = GetDlgItem(hWnd, IDC_AUTHKEY);
        EncryptKeyLength_hWnd  = GetDlgItem(hWnd, IDC_ENCRYPTKEYLEN);
        AdminPassword1_hWnd    = GetDlgItem(hWnd, IDC_ADMINPASSWORD1);
        AdminPassword2_hWnd    = GetDlgItem(hWnd, IDC_ADMINPASSWORD2);

        iLength = strlen(gsAuthString);
		sprintf(sText, "%d bits (CRC: %X)", iLength * 8, FullCRC(gsAuthString, iLength));
		Set_Text(AuthString_hWnd, sText);

		iLength = strlen(gsAuthKey);
		sprintf(sText, "%d bits (CRC: %X)", iLength * 8, FullCRC(gsAuthKey, iLength));
		Set_Text(AuthKey_hWnd, sText);

		sprintf(sText, "%d bits", gdwKeyGenLength * 8);
		Set_Text(EncryptKeyLength_hWnd, sText);

        return TRUE;
    }

    if(uMsg == WM_NOTIFY)
    {
        LPNMHDR pNMH = (LPNMHDR)lParam;
        if(pNMH->code == PSN_KILLACTIVE)
        {
            return FALSE;
        }
        if(pNMH->code == PSN_APPLY) // Ok
        {
            return TRUE;
        }
        if(pNMH->code == PSN_RESET) // Cancel
        {
            return FALSE;
        }
    }

    return FALSE;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#endif
