#ifndef _TABSERVER_H
#define _TABSERVER_H
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#include <Windows.H>
#include <Stdio.H>
#include <Stdlib.H>

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#include "../Resources/Resource.H"

#include "../../SharedSource/NSWFL.H"
#include "../Source/Entry.H"
#include "../Source/Init.H"
#include "../Source/WinService.H"
#include "../Source/Routines.H"

#include "../CSockSrvr/CSockSrvr.H"

#include "../Dialogs/MainDlg.H"

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

BOOL CALLBACK TabServerDialog(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
    static HWND ListenPort_hWnd;
    static HWND MaxClients_hWnd;
    static HWND NextClientID_hWnd;
    static HWND CompressMethod_hWnd;

    if(uMsg == WM_INITDIALOG)
    {
        ListenPort_hWnd     = GetDlgItem(hWnd, IDC_LISTENPORT);
        MaxClients_hWnd     = GetDlgItem(hWnd, IDC_MAXCONNECTS);
		NextClientID_hWnd   = GetDlgItem(hWnd, IDD_NEXTCLIENTID);
		CompressMethod_hWnd = GetDlgItem(hWnd, IDC_COMPRESSMETHOD);

		Set_Long(ListenPort_hWnd, gdwListenPort);
        Set_Long(MaxClients_hWnd, gdwMaxClients);
        Set_Long(NextClientID_hWnd, gdwNextClientID);

        SendMessage(CompressMethod_hWnd, (UINT)CB_ADDSTRING, (WPARAM)0, (LPARAM)"None");
        SendMessage(CompressMethod_hWnd, (UINT)CB_ADDSTRING, (WPARAM)0, (LPARAM)"LZSS");
        SendMessage(CompressMethod_hWnd, (UINT)CB_ADDSTRING, (WPARAM)0, (LPARAM)"LZARI");
        SendMessage(CompressMethod_hWnd, (UINT)CB_ADDSTRING, (WPARAM)0, (LPARAM)"RLE");

		int iIndex = SendMessage(CompressMethod_hWnd, (UINT)CB_FINDSTRING, (WPARAM)-1, (LPARAM) gsCompressionMethod);
		SendMessage(CompressMethod_hWnd, (UINT)CB_SETCURSEL, (WPARAM)iIndex, (LPARAM)NULL);

		return TRUE;
    }

    if(uMsg == WM_NOTIFY)
    {
        LPNMHDR pNMH = (LPNMHDR)lParam;
        if(pNMH->code == PSN_KILLACTIVE)
        {
            return FALSE;
        }
        if(pNMH->code == PSN_APPLY) // Ok
        {
            Get_TextEx(CompressMethod_hWnd, gsCompressionMethod, sizeof(gsCompressionMethod));

			return TRUE;
        }
        if(pNMH->code == PSN_RESET) // Cancel
        {
            return FALSE;
        }
    }

    return FALSE;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#endif
